import { Component, h, Prop, State } from '@stencil/core';
import { randomIdGenerator } from '../../../global/utils/randomIdGenerator';

@Component({
	tag: 'digi-icon-settings',
	styleUrl: 'icon-settings.scss',
	scoped: true
})
export class IconSettings {
	/**
	 * Lägger till ett titleelement i svg:n
	 * @en Adds a title element inside the svg
	 */
	@Prop() afTitle: string;

	/**
	 * Lägger till ett descelement i svg:n
	 * @en Adds a desc element inside the svg
	 */
	@Prop() afDesc: string;

	/**
	 * För att dölja ikonen för skärmläsare. Default är satt till true.
	 * @en Hides the icon for screen readers. Default is set to true.
	 */
	@Prop() afSvgAriaHidden: boolean = true;

	

	/**
* Referera till andra element på sidan för att definiera ett tillgängligt namn.
* @en Reference other elements on the page to define an accessible name.
*/
@Prop() afSvgAriaLabelledby: string;

@State() titleId: string = randomIdGenerator('icontitle');

	render() {
		return (
			<svg
				class="digi-icon-settings"
				width="48"
				height="48"
				viewBox="0 0 48 48"
				xmlns="http://www.w3.org/2000/svg"
				aria-hidden={this.afSvgAriaHidden ? 'true' : 'false'}
				aria-labelledby={this.afSvgAriaLabelledby ? this.afSvgAriaLabelledby : this.afTitle ? this.titleId : undefined}
			>
				{this.afTitle && <title id={this.titleId}>{this.afTitle}</title>}
				{this.afDesc && <desc>{this.afDesc}</desc>}
				<path
					class="digi-icon-settings__shape"
					d="M29.3370795,0.58437877 C29.871186,0.70343058 30.2523914,1.17337194 30.2523914,1.71850391 L30.2523914,6.47848768 C32.4097627,7.24083699 34.4079493,8.39167115 36.1464135,9.87877446 L40.281026,7.49773826 C40.7502019,7.22621659 41.3513335,7.31602761 41.7178772,7.71704423 C44.1182145,10.302766 45.9530274,13.421088 47.0275239,16.8694132 C47.1888031,17.387393 46.9688769,17.9513226 46.4976065,18.2228443 L42.3608995,20.6038805 C42.7756174,22.8491559 42.7756174,25.1508242 42.3608995,27.3960996 L46.4976065,29.7771358 C46.9688769,30.0486574 47.1888031,30.6104984 47.0275239,31.1305669 C45.9530274,34.5788921 44.1182145,37.6972141 41.7178772,40.2850245 C41.3513335,40.6818638 40.7502019,40.7737635 40.281026,40.5022418 L36.1464135,38.1232942 C34.4079493,39.6083089 32.4097627,40.7591431 30.2502969,41.5214924 L30.2502969,46.2814762 C30.2502969,46.8266081 29.8732806,47.2944609 29.3412686,47.4156013 C25.9481216,48.1737733 22.3057248,48.2155459 18.7408259,47.4156013 C18.208814,47.2965495 17.8297031,46.8266081 17.8297031,46.2814762 L17.8297031,41.5214924 C15.6702373,40.7591431 13.6720507,39.6083089 11.931492,38.1232942 L7.80106852,40.5022418 C7.32770356,40.7737635 6.73076103,40.6818638 6.3600283,40.2850245 C3.96178548,37.6972141 2.12697264,34.5788921 1.05247607,31.1305669 C0.891196863,30.6104984 1.11112306,30.0486574 1.58239348,29.7771358 L5.71910052,27.3960996 C5.30228801,25.1508242 5.30228801,22.8491559 5.71910052,20.6038805 L1.58239348,18.2228443 C1.11112306,17.9513226 0.891196863,17.387393 1.05247607,16.8694132 C2.12697264,13.421088 3.96178548,10.302766 6.3600283,7.71704423 C6.73076103,7.31602761 7.32770356,7.22621659 7.80106852,7.49773826 L11.9335865,9.87877446 C13.6720507,8.39167115 15.6702373,7.24083699 17.8297031,6.47848768 L17.8297031,1.71850391 C17.8297031,1.17546056 18.2067194,0.70343058 18.7387314,0.58437877 C22.1318784,-0.175881911 25.7742752,-0.21347722 29.3370795,0.58437877 Z M24.04,17.28 C19.8053305,17.28 16.36,20.7683971 16.36,25.056 C16.36,29.3436029 19.8053305,32.832 24.04,32.832 C28.2746695,32.832 31.72,29.3436029 31.72,25.056 C31.72,20.7683971 28.2746695,17.28 24.04,17.28 Z"
					fill="currentColor"
					fill-rule="nonzero"
				/>
			</svg>
		);
	}
}
